#include <iostream>
#include<vector>
using namespace std;

int main()
{
   int n,m;
   cin>>n>>m;
   if(n==1){
     vector<int>c(m);
    vector<int>d(m);
     vector<int>k(m);
    int a,b,z=0,br=0,br2=m;
    cin>>a>>b;
     for(int i=0;i<m;i++){cin>>c[i]>>d[i];z+=c[i];}
    z=b-z;
    for(int i=0;i<m;i++){
    if(z>=d[i]-c[i]){z-=d[i]-c[i];k[i]=d[i];}
       else {
            k[i]=c[i]+z;
       z=0;
        }
      br+=k[i];
      if(k[i]==0)br2--;
    }
    cout<<br<<endl;
    cout<<br2<<endl;
    for(int i=0;i<m;i++)
    if(k[i]>0){
     cout<<1<<" "<<i+1<<" "<<k[i]<<endl;

    }
   }
  /*else
  { vector<int>a(n);
    vector<int>b(n);
    vector<int>c(m);
    vector<int>d(m);
    for(int i=0;i<n;i++){
    cin>>a[i]>>b[i];
       // if(a[i]!=b[i])k=0;

    }
    for(int i=0;i<m;i++)cin>>c[i]>>d[i];
    //vector<vector<int>>a(n);
   // f(n1,n2,m1,m2,n,m,)
  int r[50000][50000];
   for(int i=0;i<n;i++)
    for(int i=0;i<m;i++)cin>>r[n][m];}

*/
 return 0;
}